Index: /trunk/gli/src/org/greenstone/gatherer/cdm/PlugInManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/PlugInManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/PlugInManager.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,20 +25,6 @@
  *########################################################################
  */
-
- 
-
-
-
-
 package org.greenstone.gatherer.cdm;
-/**
- * Title:        The Gatherer<br>
- * Description:  The Gatherer: a tool for gathering and enriching digital collections.<br>
- * Copyright:    Copyright (c) 2001<br>
- * Company:      The University of Waikato<br>
- * First Coded:  01/05/02
- * @author John Thompson, Greenstone Digital Libraries
- * @version 2.1
- */
+
 import java.awt.*;
 import java.awt.event.*;
@@ -57,94 +33,97 @@
 import javax.swing.*;
 import javax.swing.event.*;
-import javax.swing.plaf.basic.BasicArrowButton;
-import org.apache.xerces.parsers.DOMParser;
+import javax.swing.plaf.basic.*;
+import org.apache.xerces.parsers.*;
 import org.greenstone.gatherer.Gatherer;
 import org.greenstone.gatherer.cdm.Argument;
 import org.greenstone.gatherer.cdm.ArgumentConfiguration;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
 import org.greenstone.gatherer.cdm.CommandTokenizer;
+import org.greenstone.gatherer.cdm.Control;
 import org.greenstone.gatherer.cdm.DynamicListModel;
 import org.greenstone.gatherer.cdm.PlugIn;
-import org.greenstone.gatherer.msm.ElementWrapper;
+import org.greenstone.gatherer.gui.GComboBox;
 import org.greenstone.gatherer.msm.MSMUtils;
+import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.Utility;
 import org.w3c.dom.*;
-import org.xml.sax.InputSource;
+import org.xml.sax.*;
 /** This class is resposible for maintaining a list of known plug-ins, and importing new plugins using the parser. */
-public class PlugInManager {
-    /** A reference to the main manager for this module. */
-    private CollectionDesignManager manager = null;
+public class PlugInManager 
+    extends DOMProxyListModel {
+    /** The library 'reserve' of base plugins. */
+    private ArrayList library = null;
     /** The controls for editing the contents of this manager. */
     private Control controls = null;
-    /** A list of assigned plugins. */
-    private DynamicListModel assigned = null;
-    /** A list of those plugins that have not yet been assigned. Begins as a copy of reserve. */
-    private DynamicListModel available = null;
-    /** A list of known, but currently unassigned, plug-ins. */
-    private DynamicListModel reserve = null;
-    /** A reference to the Gatherer. */
-    private Gatherer gatherer = null;
-    /** The current index of the separator. */
-    private JPanel separator = null;
+    private DOMProxyListModel model;
+    private JPanel separator;
+    private PlugIn separator_plugin; 
     /** The default size for a label. */
     static final private Dimension LABEL_SIZE = new Dimension(140, 20);
     /** Constructor.
      */
-    public PlugInManager(Gatherer gatherer, CollectionDesignManager manager) {
-	this.assigned = new DynamicListModel();
-	this.gatherer = gatherer;
-	this.manager = manager;
-	this.separator = getSeparator();
-	// Add the movement separator
-	assigned.addElement(separator);
+    public PlugInManager() {
+	super(CollectionDesignManager.collect_config.getDocumentElement(), CollectionConfiguration.PLUGIN_ELEMENT, new PlugIn());
+	Gatherer.println("PlugInManager: " + getSize() + " plugins parsed.");
+	model = this;
+	// Reload/Create the library
 	loadPlugIns();
 	savePlugIns();
-    }
-    /** Method to add a new plugin to reserve.
-	  * @param plugin The new <strong>PlugIn</strong>.
-	  */
+	// Create the separator, cause we can reuse it.
+	separator = getSeparator();
+    }
+    /** Method to add a new plugin to the library
+     * @param plugin the new base PlugIn
+     */
     public void addPlugIn(PlugIn plugin) {
-	if(!reserve.contains(plugin)) {
-	    reserve.addElement(plugin);
-	    available.addElement(plugin);
-	}
-    }
-    /** Method to assign a plugin.
-	  * @param plugin The reserve <strong>PlugIn</strong> to assign.
-	  */
+	if(!library.contains(plugin)) {
+	    library.add(plugin);
+	}
+    }
+
+    /** Method to assign a plugin
+     * @param plugin the PlugIn to assign
+     */
     public void assignPlugIn(PlugIn plugin) {
-	if(!assigned.contains(plugin)) {
-	    if(plugin.getName().equals("RecPlug") || plugin.getName().equals("ArcPlug")) {
-		assigned.addElement(plugin); // Adds after separator
-	    }
-	    else {
-		int index = assigned.indexOf(separator);
-		assigned.add(index, plugin);
-	    }
-				// Remove from available
-	    available.removeElement(plugin);
-	    gatherer.c_man.configurationChanged();
-	}
-    }
+	if(plugin.getName().equals(StaticStrings.RECPLUG_STR) || plugin.getName().equals(StaticStrings.ARCPLUG_STR)) {
+	    addAfter(plugin, separator_plugin); // Adds after separator
+	}
+	else {
+	    addBefore(plugin, separator_plugin);
+	}
+	Gatherer.c_man.configurationChanged();
+    }
+
+    /** Destructor. */
+    public void destroy() {
+	if(controls != null) {
+	    controls.destroy();
+	    controls = null;
+	}
+	library.clear();
+	library = null;
+    }
+
     /** Method to retrieve the control for this manager.
-	  * @return A <strong>JPanel</strong> containing the controls.
-	  */
-    public JPanel getControls() {
+     * @return the Control
+     */
+    public Control getControls() {
 	if(controls == null) {
-	    controls = new Control();
+	    // Build controls
+	    controls = new PlugInControl();
 	}
 	return controls;
     }
-    /** Method to retrieve the named plugin.
-	  * @param name The name of the desired plugin as a <strong>String</strong>.
-	  * @return The requested <strong>PlugIn</strong> or <i>null</i> if no such plugin exists.
-	  */
-    public PlugIn getPlugIn(String name) {
-	for(int i = 0; i < reserve.size(); i++) {
-	    Object object = reserve.get(i);
-	    if(object instanceof PlugIn) {
-		PlugIn plugin = (PlugIn) object;
-		if(plugin.getName().equals(name)) {
-		    return plugin;
-		}
+
+    /** Retrieve the base pluging of the given name, or null if no such plugin.
+     * @param name the name of the base plugin to retrieve as a String
+     * @return the PlugIn requested or null if no such plugin
+     */
+    public PlugIn getBasePlugIn(String name) {
+	int library_size = library.size();
+	for(int i = 0; i < library_size; i++) {
+	    PlugIn plugin = (PlugIn) library.get(i);
+	    if(plugin.getName().equals(name)) {
+		return plugin;
 	    }
 	}
@@ -152,16 +131,202 @@
 	return null;
     }
-    /** Method to invalidate controls after a significant change in the system state.
-	  */
-    public void invalidateControls() {
-	if(controls != null) {
-	    controls.destroy();
-	}
-	controls = null;
-    }
+
+    /** Method to move a plugin in the list order.
+     * @param plugin the PlugIn you want to move.
+     * @param direction true to move the plugin up, false to move it down.
+     * @param all true to move to move all the way, false for a single step.
+     */
+    public void movePlugIn(PlugIn plugin, boolean direction, boolean all) {
+	// Can't ever move RecPlug or ArcPlug.
+	if(getSize() < 3) {
+	    Gatherer.println("Not enough plugins to allow moving.");
+	    return;
+	}
+	if(plugin.getName().equals(StaticStrings.ARCPLUG_STR) || plugin.getName().equals(StaticStrings.RECPLUG_STR)) {
+	    JOptionPane.showMessageDialog(Gatherer.g_man, get("CDM.Move.Fixed"), get("CDM.Move.Title"), JOptionPane.ERROR_MESSAGE);
+	    return;
+	}
+	if(all) {
+	    // Move to top
+	    if(direction) {
+		// Remove the moving plugin
+		remove(plugin);
+		// Retrieve the first plugin
+		PlugIn first_plugin = (PlugIn) getElementAt(0);
+		// Add the moving plugin before the first plugin
+		addBefore(plugin, first_plugin);
+		first_plugin = null;
+		Gatherer.c_man.configurationChanged();
+	    }
+	    else {
+		// Remove the moving plugin
+		remove(plugin);
+		// Locate the plugin immediately before the separator. We have to ensure the separator index is up to date, given we've just removed a plugin.
+		int separator_index = -1;
+		if((separator_index = findSeparatorIndex()) != -1) {
+		    PlugIn separator_plugin = (PlugIn) getElementAt(separator_index);
+		    // Add the moving plugin before the separator
+		    addBefore(plugin, separator_plugin);
+		    Gatherer.c_man.configurationChanged();	    
+		}
+		// Otherwise we aren't moving anywhere!
+	    }
+	}
+	else {
+	    // Try to move the plugin one step in the desired direction.
+	    int index = indexOf(plugin);
+	    ///ystem.err.println("Index of " + plugin + " = " + index);
+	    if(direction) {
+		index--;
+		if(index < 0) {
+		    String args[] = new String[2];
+		    args[0] = get("CDM.PlugInManager.PlugIn_Str");
+		    args[1] = plugin.getName();
+		    JOptionPane.showMessageDialog(Gatherer.g_man, get("CDM.Move.At_Top", args), get("CDM.Move.Title"), JOptionPane.ERROR_MESSAGE);
+		    return;
+		}
+		remove(plugin);
+		add(index, plugin);
+		Gatherer.c_man.configurationChanged(); 
+	    }
+	    else {
+		index++;
+		PlugIn next_plugin = (PlugIn) getElementAt(index);
+		if(next_plugin.isSeparator()) {
+		    String args[] = new String[1];
+		    args[0] = plugin.getName();
+		    JOptionPane.showMessageDialog(Gatherer.g_man, get("CDM.Move.Cannot", args), get("CDM.Move.Title"), JOptionPane.ERROR_MESSAGE);
+		    // Still not going to move RecPlug or ArcPlug.
+		    return;
+		}
+		remove(plugin);
+		add(index, plugin);
+		Gatherer.c_man.configurationChanged();
+	    }
+	}
+    }
+
+    /** We attempt to place the separator between the unfixed and the fixed plugins. Since we only know of two fixed plugins, we search for either of them, and place the separator before them.
+     */
+    public void placeSeparator() {
+	///ystem.err.println("Placing separator.");
+	int separator_index = getSize();
+	if(separator_index > 0) {
+	    boolean found_fixed = false;
+	    int index = separator_index - 1;
+	    while(index > 0) {
+		PlugIn plugin = (PlugIn) getElementAt(index);
+		String name = plugin.getName();
+		if(name.equals(StaticStrings.RECPLUG_STR) || name.equals(StaticStrings.ARCPLUG_STR)) {
+		    found_fixed = true;
+		    index--;
+		}
+		else {
+		    if(found_fixed) {
+			separator_index = index + 1;
+			index = -1;
+		    }
+		    else {
+			index--;
+		    }
+		}
+		name = null;
+		plugin = null;
+	    }
+	}
+	Element element = CollectionDesignManager.collect_config.document.createElement(CollectionConfiguration.PLUGIN_ELEMENT);
+	element.setAttribute(CollectionConfiguration.TYPE_ATTRIBUTE, CollectionConfiguration.SEPARATOR_ATTRIBUTE);
+	element.setAttribute(CollectionConfiguration.SEPARATOR_ATTRIBUTE, CollectionConfiguration.TRUE_STR);
+	separator_plugin = new PlugIn(element, null);
+	///atherer.println("Adding plugin separator at: " + separator_index);
+	add(separator_index, separator_plugin);
+    }
+
+    /** This method removes an assigned plugin. I was tempted to call it unassign, but remove is more consistant. Note that there is no way to remove a plugin from the library.
+     * @param plugin The <strong>PlugIn</strong> to remove.
+     */
+    public void removePlugIn(PlugIn plugin) {
+	remove(plugin);
+	Gatherer.c_man.configurationChanged();
+    }
+
+    /** Method to cache the current contents of library (known plugins) to file.
+     */
+    public void savePlugIns() {
+	try {
+	    FileOutputStream file = new FileOutputStream(Utility.BASE_DIR + "plugins.dat");
+	    ObjectOutputStream out = new ObjectOutputStream(file);
+	    out.writeObject(library);
+	    out.close();
+	}
+	catch (Exception error) {
+	    Gatherer.printStackTrace(error);
+	}
+    }
+
+    /** Determine the current separator index. */
+    private int findSeparatorIndex() {
+	int separator_index = getSize() - 1;
+	while(separator_index >= 0) {
+	    PlugIn search = (PlugIn) getElementAt(separator_index);
+	    if(search.isSeparator()) {
+		return separator_index;
+	    }
+	    separator_index--;
+	}
+	return separator_index;
+    }
+
+    /* Retrieve a phrase from the dictionary based on a certain key.
+     * @param key The search <strong>String</strong>.
+     * @return The matching phrase from the Dictionary.
+     */
+    private String get(String key) {
+	return get(key, (String[])null);
+    }
+    
+    private String get(String key, String arg) {
+	String args[] = new String[1];
+	args[0] = arg;
+	return get(key, args);
+    }
+
+    /* Retrieve a phrase from the dictionary based on a certain key and arguments.
+     * @param key The search <strong>String</strong>.
+     * @param args A <strong>String[]</strong> of arguments used to complete and format the choosen phrase.
+     * @return The matching phrase from the Dictionary.
+     */
+    private String get(String key, String args[]) {
+	if(key.indexOf(".") == -1) {
+	    key = "CDM.PlugInManager." + key;
+	}
+	return Gatherer.dictionary.get(key, args);
+    }	 
+
+    /** Retrieve a list of those plugins that are in library but not in the assigned plugins. */
+    private Object[] getAvailable() {
+	ArrayList available = new ArrayList();
+	available.addAll(library);
+	// Now go through the assigned plugins, and remove any that match.
+	available.removeAll(children());
+	return available.toArray();
+    }
+
+    /** Method to extract just the plugins name from a file object.
+     * @param plugin The <strong>File</strong> which references a certain plugin.
+     * @return A <strong>String</strong> containing just the plugins name, without extension.
+     */
+    private String getPlugInName(File plugin) {
+	String name = plugin.getName();
+	if(name.indexOf(".") != -1) {
+	    name = name.substring(0, name.indexOf("."));
+	}
+	return name;
+    }
+
     /** Method to load the details of a single plug-in.
-	  * @param plugin The plugin <strong>File</strong> you wish to load.
-	  */
-    public void loadPlugIn(File plugin) {
+     * @param plugin The plugin <strong>File</strong> you wish to load.
+     */
+    private void loadPlugIn(File plugin) {
 	Document document = null;
 	// Run pluginfo on this plugin, and then send the results for parsing.
@@ -170,11 +335,11 @@
 	    if(Utility.isWindows()) {
 		args = new String[4];
-		if(gatherer.config.perl_path != null) {
-		    args[0] = gatherer.config.perl_path;
+		if(Gatherer.config.perl_path != null) {
+		    args[0] = Gatherer.config.perl_path;
 		}
 		else {
 		    args[0] = "Perl.exe";
 		}
-		args[1] = gatherer.config.gsdl_path + "bin" + File.separator + "script" + File.separator + "pluginfo.pl";
+		args[1] = Gatherer.config.gsdl_path + "bin" + File.separator + "script" + File.separator + "pluginfo.pl";
 		args[2] = "-xml";
 		args[3] = getPlugInName(plugin);
@@ -229,280 +394,8 @@
 	}
 	if(document != null) {
-	    parse(document.getDocumentElement());
-	}
-    }
-    /** Method to move a plugin higher in the list order.
-	  * @param plugin The <strong>PlugIn</strong> you want to move.
-	  * @param direction <i>true</i> to move the plugin up, <i>false</i> to move it down.
-	  * @param all <i>true</i> to move to move all the way, <i>false</i> for a single step.
-	  */
-    public void movePlugIn(PlugIn plugin, boolean direction, boolean all) {
-	// Can't ever move RecPlug or ArcPlug.
-	if(plugin.getName().equals("ArcPlug") || plugin.getName().equals("RecPlug")) {
-	    JOptionPane.showMessageDialog(manager.gui, get("CDM.Move.Fixed"), get("CDM.Move.Title"), JOptionPane.ERROR_MESSAGE);
-	    return;
-	}
-	if(all) {
-	    if(direction) {
-		assigned.removeElement(plugin);
-		assigned.add(0, plugin);
-		gatherer.c_man.configurationChanged();
-	    }
-	    else {
-		assigned.removeElement(plugin);
-		int index = assigned.size() - 1;
-		boolean found = false;
-		while(!found) {
-		    Object temp = assigned.get(index);
-		    if(temp instanceof PlugIn) {
-			PlugIn current = (PlugIn) temp;
-			if(current.getName().equals("ArcPlug") || current.getName().equals("RecPlug")) {
-			    index--;
-			}
-			else {
-			    found = true;
-			}
-		    }
-		    else {
-			found = true;
-		    }
-		}
-		assigned.add(index, plugin);
-		gatherer.c_man.configurationChanged();
-	    }
-	}
-	else {
-				// Try to move the plugin one step in the desired direction.
-	    int index = assigned.indexOf(plugin);
-				///ystem.err.println("Index of " + plugin + " = " + index);
-	    if(direction) {
-		index--;
-		if(index < 0) {
-		    String args[] = new String[1];
-		    args[0] = plugin.getName();
-		    JOptionPane.showMessageDialog(manager.gui, get("CDM.Move.At_Top", args), get("CDM.Move.Title"), JOptionPane.ERROR_MESSAGE);
-		    return;
-		}
-		assigned.removeElement(plugin);
-		assigned.add(index, plugin);
-		gatherer.c_man.configurationChanged(); 
-	    }
-	    else {
-		index++;
-		Object object = assigned.get(index);
-		if(index == assigned.size()) {
-		    String args[] = new String[1];
-		    args[0] = plugin.getName();
-		    JOptionPane.showMessageDialog(manager.gui, get("CDM.Move.At_Bottom", args), get("CDM.Move.Title"), JOptionPane.ERROR_MESSAGE);
-		    // Still not going to move RecPlug or ArcPlug.
-		    return;
-		}
-		else if(!(object instanceof PlugIn) || ((PlugIn)object).getName().equals("ArcPlug") || ((PlugIn)object).getName().equals("RecPlug")) {
-		    String args[] = new String[1];
-		    args[0] = plugin.getName();
-		    JOptionPane.showMessageDialog(manager.gui, get("CDM.Move.Cannot", args), get("CDM.Move.Title"), JOptionPane.ERROR_MESSAGE);
-		    // Still not going to move RecPlug or ArcPlug.
-		    return;
-		}
-		assigned.removeElement(plugin);
-		assigned.add(index, plugin);
-		gatherer.c_man.configurationChanged();
-	    }
-	}
-    }
-
-    /** This method attempts to parse a plugin command from a command string taken from the collection configuration file. This process is quite complex as not only must the correct plugin be matched by also all of the parameters given must be legal. If such a command is found, the plugin is immediately assigned.
-	  * @param command The coomand <strong>String</strong> that may include plugin information.
-	  * @return <i>true</i> if a plugin command was parsed, <i>false</i> otherwise.
-	  */
-    public boolean parse(String command) {
-	String command_lc = command.toLowerCase();
-	if(command_lc.startsWith("plugin")) {
-	    CommandTokenizer tokenizer = new CommandTokenizer(command);
-	    if(tokenizer.countTokens() >= 2) {
-		tokenizer.nextToken(); // Throw away 'plugin'
-		String name = tokenizer.nextToken();
-		// Try to locate the plugin with this name.
-		PlugIn plugin = getPlugIn(name);
-		// And if successful start to parse the arguments.
-		if(plugin != null) {
-		    // Take a copy.
-		    plugin = plugin.copy();
-		    String key = null;
-		    while(tokenizer.hasMoreTokens()) {
-			if(key == null) {
-			    key = tokenizer.nextToken();
-			}
-			// Try to retrieve a matching argument.
-			Argument argument = plugin.getArgument(key);
-			if(argument != null) {
-			    // Set as assigned.
-			    argument.setAssigned(true);
-			    // And if the argument is of a parameter type, parse a parameter.
-			    if(argument.getType() != Argument.FLAG && tokenizer.hasMoreTokens()) {
-				String value = tokenizer.nextToken();
-				ElementWrapper element = null;
-				if(argument.getType() == Argument.METADATA) {
-				    value = value.replace(':', MSMUtils.NS_SEP);
-				    if (value.indexOf(MSMUtils.NS_SEP)==-1){
-					value = Utility.EXTRACTED_METADATA_NAMESPACE + MSMUtils.NS_SEP + value;
-				    }
-				    // Now retrieve the element this refers to, if available.
-				    element = Gatherer.c_man.getCollection().msm.getElement(value);
-				}
-				if(element != null) {
-				    argument.setElementValue(element);
-				    element = null;
-				}
-				else {
-				    argument.setValue(value);
-				}
-			    }
-			    key = null;
-			}
-			// Argument cannot be matched.
-			else {
-			    String cur_key = key;
-			    String value = tokenizer.nextToken();
-			    if(value.startsWith("-")) {
-				key = value;
-				value = null;
-			    }
-			    else {
-				key = null;
-			    }
-			    String custom = plugin.getCustom();
-			    if(custom == null) {
-				if(value == null) {
-				    plugin.setCustom(cur_key);
-				}
-				else {
-				    plugin.setCustom(cur_key + " " + value);
-				}
-			    }
-			    else {
-				if(value == null) {
-				    plugin.setCustom(custom + " " + cur_key);
-				}
-				else {
-				    plugin.setCustom(custom + " " + cur_key + " " + value);
-				}
-			    }
-			}
-		    }
-		    // Slight tweak. If the plugin is the RecPlug we want to set use_metadata_files by default.
-		    if(plugin.getName().equalsIgnoreCase("RecPlug")) {
-			Argument argument = plugin.getArgument("-use_metadata_files");
-			if(argument != null) {
-			    argument.setAssigned(true);
-			}
-		    }
-		    // Second tweak. If the plugin is the HTMLPlug we want to modify the block expression so our backup files are ignored.
-		    if(plugin.getName().equalsIgnoreCase("HTMLPlug")) {
-			Argument argument = plugin.getArgument("-block_exp");
-			if(argument != null) {
-			    argument.setValue(argument.getDefaultValue() + "|(~$)");
-			}
-		    }
-		    // Add the plugin to our reserve
-		    assignPlugIn(plugin);
-		    return true;
-		}
-		else {
-		    //ystem.err.println("Unknown plugin");
-		}
-	    }
-	}
-	return false;
-    }
-    /** This method removes an assigned plugin. I was tempted to call it unassign, by remove is more consistant. Note that there is no way to remove a plugin from the reserve.
-	  * @param plugin The <strong>PlugIn</strong> to remove.
-	  */
-    public void removePlugIn(PlugIn plugin) {
-	assigned.removeElement(plugin);
-	available.addElement(plugin);
-	gatherer.c_man.configurationChanged();
-    }
-    /** Method to cache the current contents of reserve (known plugins) to file.
-	  */
-    public void savePlugIns() {
-	try {
-	    FileOutputStream file = new FileOutputStream(Utility.BASE_DIR + "plugins.dat");
-	    ObjectOutputStream out = new ObjectOutputStream(file);
-	    out.writeObject(reserve);
-	    out.close();
-	}
-	catch (Exception error) {
-	}
-    }
-    /** Method used to determine the number of plugins that have been assigned.
-	  * @return An <i>int</i> which is the number of plugins.
-	  */
-    public int size() {
-	return assigned.size();
-    }
-    /** Method to print out a block of plugin commands, much like you'd find in a collection configuration file.
-	  * @return A <strong>String</strong> containing a series of plugin commands separated by new lines.
-	  */
-    public String toString() {
-	String text = "";
-	for(int i = 0; i < assigned.size(); i++) {
-	    Object object = assigned.get(i);
-	    if(object instanceof PlugIn) {
-		PlugIn plugin = (PlugIn) object;
-		text = text + plugin.toString() + "\n";
-	    }
-	}
-	text = text + "\n";
-	return text;
-    }
-    /* Retrieve a phrase from the dictionary based on a certain key.
-	  * @param key The search <strong>String</strong>.
-	  * @return The matching phrase from the Dictionary.
-	  */
-    private String get(String key) {
-	return get(key, (String[])null);
-    }
-
-    private String get(String key, String arg) {
-	String args[] = new String[1];
-	args[0] = arg;
-	return get(key, args);
-    }
-
-    /* Retrieve a phrase from the dictionary based on a certain key and arguments.
-	  * @param key The search <strong>String</strong>.
-	  * @param args A <strong>String[]</strong> of arguments used to complete and format the choosen phrase.
-	  * @return The matching phrase from the Dictionary.
-	  */
-    private String get(String key, String args[]) {
-	if(key.indexOf(".") == -1) {
-	    key = "CDM.PlugInManager." + key;
-	}
-	return gatherer.dictionary.get(key, args);
-    }	 
-    /** Method to extract just the plugins name from a file object.
-	  * @param plugin The <strong>File</strong> which references a certain plugin.
-	  * @return A <strong>String</strong> containing just the plugins name, without extension.
-	  */
-    private String getPlugInName(File plugin) {
-	String name = plugin.getName();
-	if(name.indexOf(".") != -1) {
-	    name = name.substring(0, name.indexOf("."));
-	}
-	return name;
-    }
-    /** Method to retrieve the CData value from a node. Requires a search for the #text node.
-	  * @param node The <strong>Node</strong> whose value we wish to find.
-	  * @return The value of node as a <strong>String</strong>, or <i>null</i> if no value exists.
-	  */
-    private String getValue(Node node) {
-	if(node.hasChildNodes()) {
-	    Node text = node.getFirstChild();
-				//ystem.err.println("Value of " + node.getNodeName() + " = " + text.getNodeValue());
-	    return text.getNodeValue();
-	}
-	return node.getNodeValue();
-    }
+	    parseXML(document.getDocumentElement());
+	}
+    }
+
     /** Method to initially load information from the standard plug-ins within the gsdl Perl library.
 	  */
@@ -512,15 +405,12 @@
 	    FileInputStream file = new FileInputStream(Utility.BASE_DIR + "plugins.dat");
 	    ObjectInputStream input = new ObjectInputStream(file);
-	    reserve = (DynamicListModel) input.readObject();
-	    available = reserve.shallowCopy();
+	    library = (ArrayList) input.readObject();
 	}
 	catch (Exception error) {
 	}
-	if(reserve == null) {
-	    available = new DynamicListModel();
-	    reserve = new DynamicListModel();
-	    reserve.setAutoOrder(true);
-				// Retrieve the gsdl home directory...
-	    String directory = gatherer.config.gsdl_path;
+	if(library == null) {
+	    library = new ArrayList();
+	    // Retrieve the gsdl home directory...
+	    String directory = Gatherer.config.gsdl_path;
 	    directory = directory + "perllib" + File.separator + "plugins" + File.separator;
 	    loadPlugIns(new File(directory));
@@ -533,5 +423,5 @@
 	File files[] = directory.listFiles();
 	if(files != null) {
-				// Create a progress indicator.
+	    // Create a progress indicator.
 	    ParsingProgress progress = new ParsingProgress(get("CDM.PlugInManager.Parsing.Title"), get("CDM.PlugInManager.Parsing.Message"), files.length);
 	    for(int i = 0; i < files.length; i++) {
@@ -546,5 +436,5 @@
     }
 
-    private PlugIn parse(Node root) {
+    private PlugIn parseXML(Node root) {
 	PlugIn plugin = new PlugIn();
 	String node_name = null;
@@ -553,7 +443,7 @@
 	    node_name = node.getNodeName();
 	    if(node_name.equals("Name")) {
-		String name = getValue(node);
+		String name = MSMUtils.getValue(node);
 		// We can save ourselves some processing time if a plugin with this name already exists in our manager. If so retrieve it and return it.
-		PlugIn existing = getPlugIn(name);
+		PlugIn existing = getBasePlugIn(name);
 		if(existing != null) {
 		    return existing;
@@ -562,5 +452,5 @@
 	    }
 	    else if(node_name.equals("Desc")) {
-		plugin.setDesc(getValue(node));
+		plugin.setDescription(MSMUtils.getValue(node));
 	    }
 				// Parse the multitude of arguments.
@@ -575,14 +465,14 @@
 			    node_name = det.getNodeName();
 			    if(node_name.equals("Name")) {
-				argument.setName(getValue(det));
+				argument.setName(MSMUtils.getValue(det));
 			    }
 			    else if(node_name.equals("Desc")) {
-				argument.setDesc(getValue(det));
+				argument.setDescription(MSMUtils.getValue(det));
 			    }
 			    else if(node_name.equals("Type")) {
-				argument.setType(getValue(det));
+				argument.setType(MSMUtils.getValue(det));
 			    }
 			    else if(node_name.equals("Default")) {
-				argument.setDefault(getValue(det));
+				argument.setDefaultValue(MSMUtils.getValue(det));
 			    }
 			    else if(node_name.equals("List")) {
@@ -595,8 +485,8 @@
 					    node_name = subvalue.getNodeName();
 					    if(node_name.equals("Name")) {
-						key = getValue(subvalue);
+						key = MSMUtils.getValue(subvalue);
 					    }
 					    else if(node_name.equals("Desc")) {
-						desc = getValue(subvalue);
+						desc = MSMUtils.getValue(subvalue);
 					    }
 					}
@@ -608,5 +498,5 @@
 			    }
 			    else if(node_name.equals("Required")) {
-				String v = getValue(det);
+				String v = MSMUtils.getValue(det);
 				if(v != null && v.equals("yes")) {
 				    argument.setRequired(true);
@@ -618,5 +508,5 @@
 		    // A super plugin class.
 		    else if(node_name.equals("PlugInfo")) {
-			PlugIn super_plugin = parse(arg);
+			PlugIn super_plugin = parseXML(arg);
 			plugin.setSuper(super_plugin);
 		    }
@@ -632,6 +522,7 @@
 
     /** A class which provodes controls for assigned and editing plugins. */
-    private class Control
-	extends JPanel {
+    private class PlugInControl
+	extends JPanel 
+	implements Control {
 	/** Button for adding plugins. */
 	private JButton add = null;
@@ -649,5 +540,5 @@
 	private JButton remove = null;
 	/** A combobox containing all of the known plugins, including those that may have already been assigned. */
-	private JComboBox plugin = null;
+	private GComboBox plugin = null;
 	/** The label next to the plugin combobox. */
 	private JLabel plugin_label = null;
@@ -674,6 +565,6 @@
 	/** Constructor.
 	 */
-	public Control() {
-	    Object plugins[] = reserve.toArray();
+	public PlugInControl() {
+	    Object plugins[] = library.toArray();
 	    Vector plugin_model = new Vector();
 	    for(int i = 0; i < plugins.length; i++) {
@@ -681,5 +572,5 @@
 	    }
 	    Collections.sort(plugin_model);
-				// Create
+	    // Create
 	    add = new JButton(get("Add"));
 	    add.setMnemonic(KeyEvent.VK_A);
@@ -697,5 +588,5 @@
 	    instructions.setWrapStyleWord(true);
 	    move_bottom = new JButton();
-	    JLabel move_bottom_label = new JLabel(get("Move_Bottom"));
+	    JLabel move_bottom_label = new JLabel(get("CDM.Move.Move_Bottom"));
 	    move_bottom_label.setHorizontalAlignment(JLabel.CENTER);
 	    move_bottom_label.setPreferredSize(LABEL_SIZE);
@@ -706,5 +597,5 @@
 	    move_bottom.setMnemonic(KeyEvent.VK_B);
 	    move_down = new JButton();
-	    JLabel move_down_label = new JLabel(get("Move_Down"));
+	    JLabel move_down_label = new JLabel(get("CDM.Move.Move_Down"));
 	    move_down_label.setHorizontalAlignment(JLabel.CENTER);
 	    move_down_label.setPreferredSize(LABEL_SIZE);
@@ -715,5 +606,5 @@
 	    move_down.setMnemonic(KeyEvent.VK_D);
 	    move_top = new JButton();
-	    JLabel move_top_label = new JLabel(get("Move_Top"));
+	    JLabel move_top_label = new JLabel(get("CDM.Move.Move_Top"));
 	    move_top_label.setHorizontalAlignment(JLabel.CENTER);
 	    move_top_label.setPreferredSize(LABEL_SIZE);
@@ -724,5 +615,5 @@
 	    move_top.setMnemonic(KeyEvent.VK_T);
 	    move_up = new JButton();
-	    JLabel move_up_label = new JLabel(get("Move_Up"));
+	    JLabel move_up_label = new JLabel(get("CDM.Move.Move_Up"));
 	    move_up_label.setHorizontalAlignment(JLabel.CENTER);
 	    move_up_label.setPreferredSize(LABEL_SIZE);
